#include <cassert>
#include <cinttypes>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <string.h>
#include <algorithm>
#include <cmath>
#include <cstdio>

typedef int8_t i8;
typedef int16_t i16;
typedef uint8_t ui8;
typedef uint16_t ui16;
typedef uint32_t ui32;
typedef int32_t i32;
typedef uint64_t ui64;
typedef int64_t i64;

constexpr ui64 INF = 1e18;

void dump(const std::vector<ui64>& a) {
    for (size_t i = 0; i < a.size() / 2 + 1; ++i) {
        std::cout << a[i] << " ";
    }
    std::cout << std::endl;
}

ui64 process(ui64 n, ui64 t) {
    // std::cout << "n= , t = " << n << " " << t << std::endl;
    if (n == 1 && t == 1) {
        return 1;
    }
    if (t % 2 == 0) {
        return t / 2;
    }
    if (n % 2 == 0) {
        return process((n + 1) / 2, t / 2) + (n / 2);
    } else {
        return process((n + 1) / 2, (t + 1) / 2) + (n / 2);
    }
}

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    ui64 n, q;
    std::cin >> n >> q;
    // std::vector<ui64> a(2 * n - 1);
    // for (int i = 0; i < n; ++i) {
        // a[2 * i] = i + 1;
    // }

    // ui64 last = a[2 * n - 2];
    // ui64 ind_cur = 2 * n - 2;
    // dump(a);

    // for (int i = 1; i <= n - 1; ++i) {
        // a[ind_cur - i] = last;
        // --ind_cur;
        // last = a[ind_cur];
    // }
        // dump(a);
    for (int i = 0; i < q; ++i) {
        ui64 t;
        std::cin >> t;
        std::cout << process(n, t - 1) + 1 << "\n";
        // std::cout << a[t - 1] << std::endl;
    }
    return 0;
}

