#include "testlib.h"
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);

  if (argc != 5) {
    cerr << "Usage: n, q, tail, seed" << endl;
    return 1;
  }

  long long n = atoll(argv[1]);
  int q = atoi(argv[2]);
  long long tail = atoll(argv[3]);
  cout << n << ' ' << q << endl;
  for (int i = 0; i < q; ++i) {
    cout << rnd.next(n - tail + 1, n) << endl;
  }

  return 0;
}
