#include "testlib.h"

const unsigned long long MAXN[] = {
  1000 * 1000 * 1000 * 1000 * 1000 * 1000LL,
  1000,
  200 * 1000,
  1000 * 1000 * 1000 * 1000 * 1000 * 1000LL
};

const int MAXQ[] {
  1000 * 1000,
  1000,
  200 * 1000,
  200 * 1000
};

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int group = atoi(validator.group().data());
  ensuref(0 <= group && group <= 3, "Incorrect test group");  

  long long n = inf.readLong(1, MAXN[group], "n");
  inf.readSpace();
  int q = inf.readInt(1, MAXQ[group], "q");
  inf.readEoln();
  for (int i = 0; i < q; ++i) {
    inf.readLong(1, n, "x");
    inf.readEoln();
  }
  inf.readEof();
  return 0;
}
