#include <bits/stdc++.h>

#ifdef moskupols
    #define debug(...) fprintf(stderr, __VA_ARGS__)
#else
    #define debug(...) 42
#endif

#define timestamp(x) debug("["#x"]: %.3f\n", (double)clock() / CLOCKS_PER_SEC)

#define hot(x) (x)
#define sweet(value) (value)
#define faceless

#define WHOLE(v) (v).begin(),(v).end()
#define RWHOLE(v) (v).rbegin(),(v).rend()
#define UNIQUE(v) (v).erase(unique(WHOLE(v)),(v).end())

typedef long long i64;
typedef unsigned long long ui64;
typedef long double TReal;

using namespace std;
class TSolver {
public:
    i64 n;
    int q;
    explicit TSolver(std::istream& in) {
        in >> n >> q;
    }

    void Solve() {
    }

    void PrintAnswer(std::ostream& out) const {
        for (int i = 0; i < q; ++i) {
            i64 row = 0;

            i64 x;
            cin >> x;
            --x;

            while (x) {
                // cerr << ' ' << x;
                row += (x + 1) / 2;
                if (x & 1) {
                    x = n - row - 1;
                } else {
                    x = 0;
                }
            }
            // cerr << '\n';
            out << row + 1 << '\n';
        }
    }
};

int main() {
    std::ios_base::sync_with_stdio(false);

    {
        auto solver = std::make_unique<TSolver>(std::cin);
        solver->Solve();
        solver->PrintAnswer(std::cout);
    }

    timestamp(end);
    return 0;
}
