#include <cassert>
#include <cinttypes>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <string.h>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <iomanip>

typedef int8_t i8;
typedef int16_t i16;
typedef uint8_t ui8;
typedef uint16_t ui16;
typedef uint32_t ui32;
typedef int32_t i32;
typedef uint64_t ui64;
typedef int64_t i64;

constexpr ui64 INF = 1e18;

void dump(const std::vector<ui64>& a) {
    for (size_t i = 0; i < a.size() / 2 + 1; ++i) {
        std::cout << std::setw(2) << i+1 << " " << a[i] << "\n";
    }
    std::cout << std::endl;
}

ui64 process(ui64 n, ui64 t) {
    if (t % 2 == 0) {
        return t / 2;
    }
    return process(n / 2, t / 2) + (n / 2);
}

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    ui64 n, q;
    std::cin >> n >> q;
    for (int i = 0; i < q; ++i) {
        ui64 x;
        std::cin >> x;
        --x;
        std::cout << process(n, x) + 1<< std::endl;
    }
    return 0;
}
