#include <iostream>

long long find_initial_pos(long long n, long long x) {
  if (x % 2 == 1) {
    return (x >> 1) + 1;
  }
  long long num_right = n - (x >> 1) - 1;
  return find_initial_pos(n, x + num_right + 1);
}

int main() {
  long long n, x;
  int q;
  std::cin >> n >> q;  
  for (int i = 0; i < q; ++i) {
    std::cin >> x;
    std::cout << find_initial_pos(n, x) << std::endl;
  }
  return 0;
}
