#include <cstdio>

long long find_ans_pow2(long long pow2, long long x) {
  if (x % 2 == 1) {
    return (x >> 1) + 1;
  }
  long long half_pow = pow2 >> 1;
  return half_pow + find_ans_pow2(half_pow, x >> 1);
}

int main() {
  long long n, lower_pow2 = 1, residue, x, ans;
  int q;
  scanf("%lld %d", &n, &q);
  while ((lower_pow2 << 1) <= n) {
    lower_pow2 <<= 1;
  }
  residue = n - lower_pow2;
  
  for (int i = 0; i < q; ++i) {
    scanf("%lld", &x);
    if (x % 2 == 1) {
      ans = (x >> 1) + 1;      
    } else if (x > 2 * residue) {
      ans = residue + find_ans_pow2(lower_pow2, x - 2 * residue);
    } else {
      long long empty_idx = residue - (x >> 1);
      ans = residue + find_ans_pow2(lower_pow2, lower_pow2 - empty_idx);
    }
    printf("%lld\n", ans);
  }
  return 0;
}
